Customize Column Cells

Users can customize the column cells defaultValue, validators, conditional formatting and styles.

The demo is being dynamically compiled to support real-time code editing... For quicker access to features, switch to the "JavaScript" tab for a smoother experience! :)
Description
app.js
index.html
styles.css
Copy to CodeMine

In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
//add custom column cell style
var addressStyle = {
    formatter: 'The detailed ship address: {{=CONCAT(@.shipAddress, ", ", @.shipCity)}}'
};
//The formatter in the style can be a formula or a template with the formula:
// 1. formula: =[@employee.FirstName] & "  " & [@employee.LastName]
// 2. template:  {{=[@employee.FirstName] & "  " & [@employee.LastName]}}
//The formula can extract the properties from the full row.
var employeeStyle = {
    formatter: '{{=[@employee.FirstName] & "  " & [@employee.LastName]}} ({{=[@shipRegion]}})'
};
//The formatter in the style can be a formula or a template with the formula:
// 1. formula: =[@employee.FirstName] & "  " & [@employee.LastName]
// 2. template:  {{=[@employee.FirstName] & "  " & [@employee.LastName]}}
//The formula can extract the properties from the full row.
var employeeStyle = {
    formatter: 'The employee: {{=[@employee.FirstName] & "  " & [@employee.LastName]}}'
};
var formulaRule = {
    ruleType: "formulaRule",
    formula: "@>50",
    style: {
        backColor: "pink"
    }
};
//add custom view
var myView = orderTable.addView("myView", [
    { value: "orderId", width: 100}, //set column width 100px
    { value: "orderDate", width: 200},
    { value: "freight", width: 100, conditionalFormats: [formulaRule], style: {hAlign: "center"}},
    { caption: "CompanyName", value: "customer.companyName", width: "2*"}, //set column width with star size, which will calculate actual column width by the rest size of viewport
    { value: "customer.contactName", width: "*"},
    { value: "customer.contactTitle", width: "*"},
    { value: "=[@]", caption: "Address", style: addressStyle, width: "3*"},
    { value: "employee", caption: "Employee", style: employeeStyle, width: "*"},
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:
/*REPLACE_MARKER*/ /*DO NOT DELETE THESE COMMENTS*/ window.onload = function() { var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"), { sheetCount: 0 }); initSpread(spread); }; function initSpread(spread) { spread.suspendPaint(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.bind(GC.Spread.Sheets.Events.EditStarting, function (e, args) { if (args.sheet.getValue(0, args.col, GC.Spread.Sheets.SheetArea.colHeader) === 'Customer'){ args.cancel = true; } }); //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); //add order table var orderTable = dataManager.addTable("orderTable", { remote: { read: { url: baseApiUrl + "/Order" } }, schema: { columns: { CustomerId: { lookup: { name: 'customer', columns: [ { value: "Id", width: 60 }, { value: "CompanyName", width: 200 }, { value: "ContactName", width: 140 }, { value: "ContactTitle", width: 140 } ] } } } } }); //add customer table var customerTable = dataManager.addTable("customerTable", { remote: { read: { url: baseApiUrl + "/Customer" } } }); //add employee table var employeeTable = dataManager.addTable("employeeTable", { remote: { read: { url: baseApiUrl + "/Employee" } } }); //add relationship between order table, customer table and employee table dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders"); dataManager.addRelationship(orderTable, "EmployeeId", "employee", employeeTable, "Id", "orders"); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var addressStyle = { formatter: 'Ship To: {{=CONCAT(@.ShipAddress, ", ", @.ShipCity)}}' }; var formulaRule = { ruleType: "formulaRule", formula: "@>50", style: { backColor: "pink" } }; var multiSelectStyle = { formatter: '{{=CONCAT([@customer.CompanyName], ", ", [@customer.ContactName])}}', // convert the object to string }; var myView = orderTable.addView("myView", [ { value: "Id", width: 60}, //set column width 100px { value: "OrderDate", width: 120, style: { formatter: "MM/dd/yyyy", hAlign: "center", cellButtons: [{ command: "openDateTimePicker", imageType: "dropdown", useButtonStyle: true, }]}}, { value: "Freight", width: 100, conditionalFormats: [formulaRule], style: {backColor: "white"}}, /** * customer.companyName - this is a related field from the customer table * update the customerId in orderTable by select from customer table. */ { caption: "Customer", value: "CustomerId", width: 350, style: multiSelectStyle}, /** * [=@] this column will contain the full row as a value, the formatter formula will extract the shipping address from the full row. * Format functions can be used to customize column display value * use star-size "2*" to set column width relative to the viewport width */ { value: "=[@]", caption: "Address", style: addressStyle, width: 450 }, /** * The formatter formula will extract the properties from the full row. * Format functions can be used to customize column display value. */ { caption: "Employee", value: "employee", width: 250 , style: { formatter: '{{=[@employee.FirstName] & " " & [@employee.LastName]}} ({{=[@ShipRegion]}})'} }, ]); myView.fetch().then(function() { sheet.setDataView(myView); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; }
<!doctype html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <!-- Promise Polyfill for IE, https://www.npmjs.com/package/promise-polyfill --> <script src="https://cdn.jsdelivr.net/npm/promise-polyfill@8/dist/polyfill.min.js"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-tablesheet/dist/gc.spread.sheets.tablesheet.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <link rel="stylesheet" type="text/css" href="styles.css"> </head> <body> <div class="sample-tutorial"> <div id="ss" class="sample-spreadsheets"></div> <div id="optionContainer" class="optionContainer"> </div> </div> </html>
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; }

In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import './styles.css';
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: '100%',
height: '100%',
overflow: 'hidden',
float: 'left'
};
constructor() {
}
initSpread($event: any) {
let spread = $event.spread;
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.bind(GC.Spread.Sheets.Events.EditStarting, function (e, args) {
if (args.sheet.getValue(0, args.col, GC.Spread.Sheets.SheetArea.colHeader) === 'Customer'){
args.cancel = true;
}
});
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
},
schema: {
columns: {
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
}
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add employee table
var employeeTable = dataManager.addTable("employeeTable", {
remote: {
read: {
url: baseApiUrl + "/Employee"
}
}
});
//add relationship between order table, customer table and employee table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
dataManager.addRelationship(orderTable, "EmployeeId", "employee", employeeTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var addressStyle = {
formatter: 'Ship To: {{=CONCAT(@.ShipAddress, ", ", @.ShipCity)}}'
};
var formulaRule = {
ruleType: "formulaRule",
formula: "@>50",
style: {
backColor: "pink"
}
};
var multiSelectStyle = {
formatter: '{{=CONCAT([@customer.CompanyName], ", ", [@customer.ContactName])}}', // convert the object to string
};
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60}, //set column width 100px
{ value: "OrderDate", width: 120, style: { formatter: "MM/dd/yyyy", hAlign: "center", cellButtons: [{
command: "openDateTimePicker",
imageType: "dropdown",
useButtonStyle: true,
}]}},
{ value: "Freight", width: 100, conditionalFormats: [formulaRule], style: {backColor: "white"}},
/**
* customer.companyName - this is a related field from the customer table
* update the customerId in orderTable by select from customer table.
*/
{ caption: "Customer", value: "CustomerId", width: 350, style: multiSelectStyle},
/**
* [=@] this column will contain the full row as a value, the formatter formula will extract the shipping address from the full row.
* Format functions can be used to customize column display value
* use star-size "2*" to set column width relative to the viewport width
*/
{ value: "=[@]", caption: "Address", style: addressStyle, width: 450},
/**
* The formatter formula will extract the properties from the full row.
* Format functions can be used to customize column display value.
*/
{ caption: "Employee", value: "employee", width: 250 , style: { formatter: '{{=[@employee.FirstName] & " " & [@employee.LastName]}} ({{=[@ShipRegion]}})'} },
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);

In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
export function AppFunc() {
const initSpread = (spread) => {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.bind(GC.Spread.Sheets.Events.EditStarting, function (e, args) {
if (args.sheet.getValue(0, args.col, GC.Spread.Sheets.SheetArea.colHeader) === 'Customer') {
args.cancel = true;
}
});
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
},
schema: {
columns: {
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
}
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add employee table
var employeeTable = dataManager.addTable("employeeTable", {
remote: {
read: {
url: baseApiUrl + "/Employee"
}
}
});
//add relationship between order table, customer table and employee table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
dataManager.addRelationship(orderTable, "EmployeeId", "employee", employeeTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var addressStyle = {
formatter: 'Ship To: {{=CONCAT(@.ShipAddress, ", ", @.ShipCity)}}'
};
var formulaRule = {
ruleType: "formulaRule",
formula: "@>50",
style: {
backColor: "pink"
}
};
var multiSelectStyle = {
formatter: '{{=CONCAT([@customer.CompanyName], ", ", [@customer.ContactName])}}', // convert the object to string
};
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60 }, //set column width 100px
{
value: "OrderDate", width: 120, style: {
formatter: "MM/dd/yyyy", hAlign: "center", cellButtons: [{
command: "openDateTimePicker",
imageType: "dropdown",
useButtonStyle: true,
}]
}
},
{ value: "Freight", width: 100, conditionalFormats: [formulaRule], style: { backColor: "white" } },
/**
* customer.companyName - this is a related field from the customer table
* update the customerId in orderTable by select from customer table.
*/
{ caption: "Customer", value: "CustomerId", width: 350, style: multiSelectStyle },
/**
* [=@] this column will contain the full row as a value, the formatter formula will extract the shipping address from the full row.
* Format functions can be used to customize column display value
* use star-size "2*" to set column width relative to the viewport width
*/
{ value: "=[@]", caption: "Address", style: addressStyle, width: 450 },
/**
* The formatter formula will extract the properties from the full row.
* Format functions can be used to customize column display value.
*/
{ caption: "Employee", value: "employee", width: 250, style: { formatter: '{{=[@employee.FirstName] & " " & [@employee.LastName]}} ({{=[@ShipRegion]}})' } },
]);
myView.fetch().then(function () {
sheet.setDataView(myView);
});
spread.resumePaint();
}
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
/*REPLACE_MARKER*/
/*DO NOT DELETE THESE COMMENTS*/
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import "@mescius/spread-sheets-tablesheet";
import { SpreadSheets } from '@mescius/spread-sheets-react';
import './styles.css';
const Component = React.Component;
export class App extends Component {
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
</SpreadSheets>
</div>
</div>
);
}
initSpread(spread) {
spread.suspendPaint();
spread.clearSheets();
spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader;
spread.bind(GC.Spread.Sheets.Events.EditStarting, function (e, args) {
if (args.sheet.getValue(0, args.col, GC.Spread.Sheets.SheetArea.colHeader) === 'Customer'){
args.cancel = true;
}
});
//init a data manager
var baseApiUrl = getBaseApiUrl();
var dataManager = spread.dataManager();
//add order table
var orderTable = dataManager.addTable("orderTable", {
remote: {
read: {
url: baseApiUrl + "/Order"
}
},
schema: {
columns: {
CustomerId: {
lookup: {
name: 'customer', columns: [
{ value: "Id", width: 60 },
{ value: "CompanyName", width: 200 },
{ value: "ContactName", width: 140 },
{ value: "ContactTitle", width: 140 }
]
}
}
}
}
});
//add customer table
var customerTable = dataManager.addTable("customerTable", {
remote: {
read: {
url: baseApiUrl + "/Customer"
}
}
});
//add employee table
var employeeTable = dataManager.addTable("employeeTable", {
remote: {
read: {
url: baseApiUrl + "/Employee"
}
}
});
//add relationship between order table, customer table and employee table
dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders");
dataManager.addRelationship(orderTable, "EmployeeId", "employee", employeeTable, "Id", "orders");
//init a table sheet
var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet);
sheet.options.allowAddNew = false; //hide new row
//bind a view to the table sheet
var addressStyle = {
formatter: 'Ship To: {{=CONCAT(@.ShipAddress, ", ", @.ShipCity)}}'
};
var formulaRule = {
ruleType: "formulaRule",
formula: "@>50",
style: {
backColor: "pink"
}
};
var multiSelectStyle = {
formatter: '{{=CONCAT([@customer.CompanyName], ", ", [@customer.ContactName])}}', // convert the object to string
};
var myView = orderTable.addView("myView", [
{ value: "Id", width: 60}, //set column width 100px
{ value: "OrderDate", width: 120, style: { formatter: "MM/dd/yyyy", hAlign: "center", cellButtons: [{
command: "openDateTimePicker",
imageType: "dropdown",
useButtonStyle: true,
}]}},
{ value: "Freight", width: 100, conditionalFormats: [formulaRule], style: {backColor: "white"}},
/**
* customer.companyName - this is a related field from the customer table
* update the customerId in orderTable by select from customer table.
*/
{ caption: "Customer", value: "CustomerId", width: 350, style: multiSelectStyle},
/**
* [=@] this column will contain the full row as a value, the formatter formula will extract the shipping address from the full row.
* Format functions can be used to customize column display value
* use star-size "2*" to set column width relative to the viewport width
*/
{ value: "=[@]", caption: "Address", style: addressStyle, width: 450},
/**
* The formatter formula will extract the properties from the full row.
* Format functions can be used to customize column display value.
*/
{ caption: "Employee", value: "employee", width: 250 , style: { formatter: '{{=[@employee.FirstName] & " " & [@employee.LastName]}} ({{=[@ShipRegion]}})'} },
]);
myView.fetch().then(function() {
sheet.setDataView(myView);
});
spread.resumePaint();
}
}
function getBaseApiUrl() {
return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api';
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app" style="height: 100%;"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Customize Column Cells

Users can customize the column cells defaultValue, validators, conditional formatting and styles.

Description
app.vue
index.html
Copy to CodeMine

In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:

//add table
dataManager.addTable("myTable", {
    remote: {
        read: {
            url: "https://demodata.mescius.io/northwind/api/v1/Orders"
        }
    }
});
//add custom column cell style
var addressStyle = {
    formatter: 'The detailed ship address: {{=CONCAT(@.shipAddress, ", ", @.shipCity)}}'
};
//The formatter in the style can be a formula or a template with the formula:
// 1. formula: =[@employee.FirstName] & "  " & [@employee.LastName]
// 2. template:  {{=[@employee.FirstName] & "  " & [@employee.LastName]}}
//The formula can extract the properties from the full row.
var employeeStyle = {
    formatter: '{{=[@employee.FirstName] & "  " & [@employee.LastName]}} ({{=[@shipRegion]}})'
};
//The formatter in the style can be a formula or a template with the formula:
// 1. formula: =[@employee.FirstName] & "  " & [@employee.LastName]
// 2. template:  {{=[@employee.FirstName] & "  " & [@employee.LastName]}}
//The formula can extract the properties from the full row.
var employeeStyle = {
    formatter: 'The employee: {{=[@employee.FirstName] & "  " & [@employee.LastName]}}'
};
var formulaRule = {
    ruleType: "formulaRule",
    formula: "@>50",
    style: {
        backColor: "pink"
    }
};
//add custom view
var myView = orderTable.addView("myView", [
    { value: "orderId", width: 100}, //set column width 100px
    { value: "orderDate", width: 200},
    { value: "freight", width: 100, conditionalFormats: [formulaRule], style: {hAlign: "center"}},
    { caption: "CompanyName", value: "customer.companyName", width: "2*"}, //set column width with star size, which will calculate actual column width by the rest size of viewport
    { value: "customer.contactName", width: "*"},
    { value: "customer.contactTitle", width: "*"},
    { value: "=[@]", caption: "Address", style: addressStyle, width: "3*"},
    { value: "employee", caption: "Employee", style: employeeStyle, width: "*"},
]);
// Set custom view into tableSheet.
tableSheet.setDataView(myView);
In addition to customizing header style and caption, users can also customize style, conditional formats and validator of column cells in tableSheet view:
<template> <div class="sample-tutorial"> <gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread"> <gc-worksheet> <gc-column> </gc-column> </gc-worksheet> </gc-spread-sheets> </div> </template> <script setup> import GC from "@mescius/spread-sheets"; import { ref } from "vue"; import "@mescius/spread-sheets-tablesheet"; import "@mescius/spread-sheets-vue"; const spreadRef = ref(null); function initSpread(spread) { spread.suspendPaint(); spread.clearSheets(); spread.options.autoFitType = GC.Spread.Sheets.AutoFitType.cellWithHeader; spread.bind(GC.Spread.Sheets.Events.EditStarting, function (e, args) { if (args.sheet.getValue(0, args.col, GC.Spread.Sheets.SheetArea.colHeader) === 'Customer') { args.cancel = true; } }); //init a data manager var baseApiUrl = getBaseApiUrl(); var dataManager = spread.dataManager(); //add order table var orderTable = dataManager.addTable("orderTable", { remote: { read: { url: baseApiUrl + "/Order" } }, schema: { columns: { CustomerId: { lookup: { name: 'customer', columns: [ { value: "Id", width: 60 }, { value: "CompanyName", width: 200 }, { value: "ContactName", width: 140 }, { value: "ContactTitle", width: 140 } ] } } } } }); //add customer table var customerTable = dataManager.addTable("customerTable", { remote: { read: { url: baseApiUrl + "/Customer" } } }); //add employee table var employeeTable = dataManager.addTable("employeeTable", { remote: { read: { url: baseApiUrl + "/Employee" } } }); //add relationship between order table, customer table and employee table dataManager.addRelationship(orderTable, "CustomerId", "customer", customerTable, "Id", "orders"); dataManager.addRelationship(orderTable, "EmployeeId", "employee", employeeTable, "Id", "orders"); //init a table sheet var sheet = spread.addSheetTab(0, "TableSheet1", GC.Spread.Sheets.SheetType.tableSheet); sheet.options.allowAddNew = false; //hide new row //bind a view to the table sheet var addressStyle = { formatter: 'Ship To: {{=CONCAT(@.ShipAddress, ", ", @.ShipCity)}}' }; var formulaRule = { ruleType: "formulaRule", formula: "@>50", style: { backColor: "pink" } }; var multiSelectStyle = { formatter: '{{=CONCAT([@customer.CompanyName], ", ", [@customer.ContactName])}}', // convert the object to string }; var myView = orderTable.addView("myView", [ { value: "Id", width: 60 }, //set column width 100px { value: "OrderDate", width: 120, style: { formatter: "MM/dd/yyyy", hAlign: "center", cellButtons: [{ command: "openDateTimePicker", imageType: "dropdown", useButtonStyle: true, }] } }, { value: "Freight", width: 100, conditionalFormats: [formulaRule], style: { backColor: "white" } }, /** * customer.companyName - this is a related field from the customer table * update the customerId in orderTable by select from customer table. */ { caption: "Customer", value: "CustomerId", width: 350, style: multiSelectStyle }, /** * [=@] this column will contain the full row as a value, the formatter formula will extract the shipping address from the full row. * Format functions can be used to customize column display value * use star-size "2*" to set column width relative to the viewport width */ { value: "=[@]", caption: "Address", style: addressStyle, width: 450 }, /** * The formatter formula will extract the properties from the full row. * Format functions can be used to customize column display value. */ { caption: "Employee", value: "employee", width: 250, style: { formatter: '{{=[@employee.FirstName] & " " & [@employee.LastName]}} ({{=[@ShipRegion]}})' } }, ]); myView.fetch().then(function () { sheet.setDataView(myView); }); spread.resumePaint(); } function getBaseApiUrl() { return window.location.href.match(/http.+spreadjs\/demos\//)[0] + 'server/api'; } </script> <style scoped> #app { height: 100%; } .sample-tutorial { position: relative; height: 100%; overflow: hidden; } .sample-spreadsheets { width: 100%; height: 100%; overflow: hidden; float: left; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } </style>
<!DOCTYPE html> <html style="height:100%;font-size:14px;"> <head> <meta charset="utf-8" /> <meta http-equiv="X-UA-Compatible" content="IE=edge" /> <title>SpreadJS VUE</title> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script> <script src="./systemjs.config.js"></script> <script src="./compiler.js" type="module"></script> <script> var System = SystemJS; System.import("./src/app.js"); System.import('$DEMOROOT$/en/lib/vue3/license.js'); </script> </head> <body> <div id="app"></div> </body> </html>
(function (global) { SystemJS.config({ transpiler: 'plugin-babel', babelOptions: { es2015: true }, paths: { // paths serve as alias 'npm:': 'node_modules/' }, packageConfigPaths: [ './node_modules/*/package.json', "./node_modules/@mescius/*/package.json", "./node_modules/@babel/*/package.json", "./node_modules/@vue/*/package.json" ], map: { 'vue': "npm:vue/dist/vue.esm-browser.js", 'tiny-emitter': 'npm:tiny-emitter/index.js', 'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js', "systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js", '@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js', '@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js', '@mescius/spread-sheets-tablesheet': 'npm:@mescius/spread-sheets-tablesheet/index.js' }, meta: { '*.css': { loader: 'systemjs-plugin-css' }, '*.vue': { loader: "../plugin-vue/index.js" } } }); })(this);